/*
** Put update user information into DB after verify a user
** Class: UpdateVerifyUser
** Author: Yuping Zhu
** Date: 11-11-1999
*/

package ascdb.users;

//import package java.sql to use JDBC
import java.sql.*;

//import package javax.servlet.http to get URL parameters
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.util.Hashtable;

import ascdb.conf;
import ascdb.admin.msgManager;
import ascdb.users.UserValidation;

public class UpdateVerifyUser extends HttpServlet
{
    private Hashtable UserTable = new Hashtable();
    private Connection conn;
    private Statement stmt;
    private msgManager msg = new msgManager();

    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();    
    conf dbconf = new conf(req);
    int sponsorEmail = 0;
    UserValidation UserV = new UserValidation();

    try {
     if (UserV.Validation(req) != 10)
     {
	 out.println("You do not have this privillege!");
	 BackMainHome(out);
	 return;
     }

    // connect to DB
    openDB(req);
 
    // Read parameters from request
    readParameters(req);

    if ((req.getParameter("op")).equals("0"))
	 { out.println("OK");return;}
    
    UserTable.put("admph",dbconf.AdminPhone);
    UserTable.put("freephone",dbconf.FreePhone);
    UserTable.put("TMDemail",dbconf.TMDEmail);

    if (((String)UserTable.get("op")).equals("0"))
    // Building Access Request
    {
	msg.putHashTable(UserTable);
	out.println("OK");
	//	msg.msgSender("yuzhu@mailbox.napc.syr.edu",(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Request",dbconf.EmailServer);
	return;
    }

    // Get address ID from addresses table or generate new one
    getAddressID();
    
    // If need sponsor, get sponsor info.
    if (! ((String)UserTable.get("business")).equals("GOVERNMENT ORGANIZATION"))
    {
        if (SponsorExist() != 0)
	{
	    getUserID((String)UserTable.get("slname"),"suid");
	    LoadSponsor();
	}
	sponsorEmail = 1;
    }
 
    //    boolean SponChange =  SponUpdate();
    // update existing user record
    if (CheckRole((String)UserTable.get("uid")) == 1)
       if (UpdateUser()==1) 
       {
	  if (((String)UserTable.get("purpose")).equals("Student"))
	     UpdateCtas();
          out.println("<body bgcolor=\"#ffffff\">");
	  out.println("The user infomation has been updated!");
	  if ((sponsorEmail == 1) && (SponUpdate()))
	  {    
	      out.println("<br>Send email to sponsor...");
	      msg.putHashTable(UserTable);
	      msg.msgSender((String)UserTable.get("semail"),(String)UserTable.get("TMDemail"),(String)UserTable.get("TMDemail"),"Sponsor TMD",dbconf.EmailServer);
	      if (RecordEmail() == 0)
		 out.println("Can not load into Sponsor_email_tracking");
	   }
	   else if ((sponsorEmail == 1) && ((String)UserTable.get("accept")).equals("Y"))
	       UpdateAccept();
	}
        else
	    out.println("Can not update your user information!");
    else
        out.println("You do not have the privillege!");

    BackHome(out);

    }catch (SQLException e) {
	out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	out.println("Can not load JDBC Driver!");
    }
    }


    private void openDB(HttpServletRequest req) 
           throws ClassNotFoundException,SQLException
    {
	//	try{
	conf dbconf = new conf(req);
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);
	
	// Connect to the database
	conn =
	    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	// Create a Statement
	stmt = conn.createStatement ();
    
    }

    private void readParameters(HttpServletRequest req)
    {
	UserTable.put("admin",req.getParameter("uid"));
	UserTable.put("uid",req.getParameter("u"));
	UserTable.put("approved",req.getParameter("approved"));
	UserTable.put("surtit",req.getParameter("surtitle"));
       	UserTable.put("l_name",req.getParameter("lastname"));
	UserTable.put("f_name",req.getParameter("firstname"));
        UserTable.put("m_name",req.getParameter("middlename"));
       	UserTable.put("address",req.getParameter("address"));
      	UserTable.put("address2",req.getParameter("address2"));
	UserTable.put("room",req.getParameter("room"));
        UserTable.put("mail",req.getParameter("mail"));
	UserTable.put("city",req.getParameter("city"));
	UserTable.put("state",req.getParameter("state"));
	UserTable.put("zip",req.getParameter("zip"));
	UserTable.put("country",req.getParameter("country"));
	UserTable.put("phone",req.getParameter("phone"));
	UserTable.put("ext",req.getParameter("ext"));
	UserTable.put("alt_phone",req.getParameter("alt_phone"));
	UserTable.put("fax",req.getParameter("fax"));
       	UserTable.put("email",req.getParameter("email"));
	UserTable.put("shared",req.getParameter("shared"));
	UserTable.put("list",req.getParameter("list"));
	UserTable.put("purpose",req.getParameter("purpose"));
	if ((req.getParameter("purpose")).equals("Student"))
	{
	    UserTable.put("cta",req.getParameter("cta"));
       	    UserTable.put("cta2",req.getParameterValues("cta2"));
        }
	UserTable.put("comment",req.getParameter("comments"));
	UserTable.put("citizenship",req.getParameter("citizenship"));
	UserTable.put("nac",req.getParameter("nac_type"));
	UserTable.put("business",req.getParameter("B_type"));
       	UserTable.put("b_name",req.getParameter("b_name"));
	if (((String)UserTable.get("business")).equals("GOVERNMENT ORGANIZATION")) 
       	   UserTable.put("org",req.getParameter("userType"));
	else
	{
	    UserTable.put("accept",req.getParameter("accept"));
	    UserTable.put("sfname",req.getParameter("s_f_name"));
	    UserTable.put("slname",req.getParameter("s_l_name"));
       	    UserTable.put("org",req.getParameter("org"));
	    UserTable.put("sphone",req.getParameter("s_phone"));
	    UserTable.put("sext",req.getParameter("s_ext"));
       	    UserTable.put("sfax",req.getParameter("s_fax"));
	    UserTable.put("semail",req.getParameter("s_email"));
	}    
	
       	UserTable.put("userType",req.getParameter("userType"));
       	UserTable.put("ssn",req.getParameter("ssn"));
	
	if ((req.getParameter("op")).equals("0")) {
	    UserTable.put("passwd1",req.getParameter("passwd1"));
	    UserTable.put("passwd2",req.getParameter("passwd2"));
	}
       	UserTable.put("op",req.getParameter("op"));
	if (((String)UserTable.get("citizenship")).compareTo("United States") == 0)
	    UserTable.put("fn_indctr","N");
	else
	UserTable.put("fn_indctr","Y");
    }
	
    private int SponsorExist()
       throws SQLException
    {
	ResultSet allSponsor =stmt.executeQuery("select oracle_uid from users where first_nam = '" + (String)UserTable.get("sfname") + "' and last_nam = '" + (String)UserTable.get("slname") + "'");
	if (allSponsor.next())
	{
	    UserTable.put("suid",allSponsor.getString(1));
	    return 0;
	}
	return 1;
    }

    private void getAddressID()
          throws SQLException
    {
	int fg = 0;
	String Code = "";
	ResultSet CountryCode = stmt.executeQuery("select char_code from domain where expsn = '" + (String)UserTable.get("country") + "'");
	if (CountryCode.next())
	       Code = CountryCode.getString(1);

	ResultSet addr = stmt.executeQuery("select * from addresses order by address_id asc");
	while (addr.next())
	    if (((String)UserTable.get("address")).equals(addr.getString(2))
	      && ((String)UserTable.get("city")).equals(addr.getString(3))
	      && ((String)UserTable.get("state")).equals(addr.getString(4))
	      && ((String)UserTable.get("zip")).equals(addr.getString(5))
	      && (Code.equals(addr.getString(6))))
	     {
		UserTable.put("addr_id",addr.getString(1));
		fg = 1;
		break;
	     }
	// generate a new address record
	if (fg == 0)
	{
	    ResultSet newAddr = stmt.executeQuery("select address_seq.nextval from dual");
	    if (newAddr.next())
		UserTable.put("addr_id",newAddr.getString(1));
	    AddAddress(Code);
	}
    }

	private void AddAddress(String Code)
	      throws SQLException
	{
      	    String QueryString = "insert into addresses values ('" 
		                   + (String)UserTable.get("addr_id") + "','"
                                   + (String)UserTable.get("address") + "','"
                                   + (String)UserTable.get("city") + "','"
                                   + (String)UserTable.get("state") + "','"
                                   + (String)UserTable.get("zip") + "','"
                                   + Code + "','"
                                   + (String)UserTable.get("room") + 
                                   "',null)";

	    int addrcount = stmt.executeUpdate(QueryString);
	}
    
        private void getUserID(String lName, String id)
	      throws SQLException
	{
	    String LastName = lName;
	    int Index = LastName.indexOf('\'');
	    while ((Index > 0) && (Index < 4))
	    {
		LastName = LastName.substring(1, Index-1) + LastName.substring(Index+1,LastName.length());
		Index = LastName.indexOf('\'');
	    }
	    Index = LastName.length();
      	    if (LastName.length() > 3)
	        Index = 3;
	    String UserID = "";
	    ResultSet UserIdrset = stmt.executeQuery("select users_seq.nextval from dual");
	    if (UserIdrset.next())
    		UserID = UserIdrset.getString(1);
	    UserIdrset.close();
	    UserID = LastName.substring(0,Index) + UserID;
	    UserTable.put(id,UserID);
	}

	private void LoadSponsor()
	     throws SQLException
	{
	    String SponsorString = "insert into users(oracle_uid,create_date,user_status,user_type,address_id,submitter,first_nam,last_nam,purpose,phone,phone_ext,fax,email,organization) values ('"
		+ (String)UserTable.get("suid") 
		+ "',sysdate,'Disable','Goverment',0,'"
		+ (String)UserTable.get("uid") + "','"
		+ (String)UserTable.get("sfname") + "','"
		+ (String)UserTable.get("slname") 
		+ "','Sponsor','"
		+ (String)UserTable.get("sphone") + "','"
		+ (String)UserTable.get("sext") + "','"
		+ (String)UserTable.get("sfax") + "','"
		+ (String)UserTable.get("semail") + "','"
		+ (String)UserTable.get("org")
		+ "')";
	    int count1 = stmt.executeUpdate(SponsorString);
	    
	    String addlStr = "insert into addl_users values('"
		+ (String)UserTable.get("suid") 
		+ "','N','N','N','123"
		+ (String)UserTable.get("suid")
		+ "')";
	    count1 = stmt.executeUpdate(addlStr);
	}
	
        private boolean SponUpdate()
	      throws SQLException
        {
	    ResultSet rset = stmt.executeQuery("select spons_agency_uid from users where oracle_uid='" +(String)UserTable.get("uid") + "'");
	    if (rset.next())
		if (((String)UserTable.get("suid")).equals(rset.getString(1)))
		    return false;
	    return true;
	}
	    
	
	private int CheckRole(String me)
	      throws SQLException
	{            
	    ResultSet rset = stmt.executeQuery("select purpose from users where oracle_uid='" + me + "'");
	    while (rset.next())
     		if ((rset.getString(1)).equals("Administrator") 
		    || me.equals((String)UserTable.get("uid")))
		    return 1;
	    return 0;
	}
	       
	private int UpdateUser()
	     throws SQLException
	{
	    String UpdateString = "update users set user_type='" 
		+ (String)UserTable.get("userType") 
		+ "',address_id='" + (String)UserTable.get("addr_id") 
		+ "',first_nam='" + (String)UserTable.get("f_name") 
		+ "',last_nam='" + (String)UserTable.get("l_name") 
		+ "',middle_nam='" + (String)UserTable.get("m_name") 
		+ "',surtitle='" + (String)UserTable.get("surtit") 
		+ "',purpose='" + (String)UserTable.get("purpose") 
		+ "',citizenship='" + (String)UserTable.get("citizenship") 
		+ "',fn_indctr='" + (String)UserTable.get("fn_indctr") 
		+ "',business_type='" + (String)UserTable.get("business") 
		+ "',business_name='" + (String)UserTable.get("b_name") 
		+ "',mail_stop='" + (String)UserTable.get("mail") 
		+ "',room_num='" + (String)UserTable.get("room") 
		+ "',phone='" + (String)UserTable.get("phone") 
		+ "',phone_ext='" + (String)UserTable.get("ext") 
		+ "',alt_phone='" + (String)UserTable.get("alt_phone") 
		+ "',fax='" + (String)UserTable.get("fax") 
		+ "',email='" + (String)UserTable.get("email") 
		+ "',spons_agency_uid='" + (String)UserTable.get("suid") 
		+ "',organization='" + (String)UserTable.get("org") 
		+ "',nac_type='" + (String)UserTable.get("nac") 
		+ "',ssan_last4='" + (String)UserTable.get("ssn") 
		+ "',user_comment='" + (String)UserTable.get("comment")
		+ "'";
	        
	        if (((String)UserTable.get("approved")).equals("Y"))
		    UpdateString = UpdateString + ",approved_date=sysdate";

		UpdateString = UpdateString + " where oracle_uid='" + (String)UserTable.get("uid") + "'";
	    int count = stmt.executeUpdate(UpdateString);
	
	    // Update additional user table
	    String AddlUpdateString = "update addl_users set share_email='" 
		+ (String)UserTable.get("shared")
		+ "',list_email='" + (String)UserTable.get("list")
		//+ "',tmd_password='" + (String)UserTable.get("passwd1")
		+ "'where oracle_uid='" + (String)UserTable.get("uid") + "'";
	    int count1 = stmt.executeUpdate(AddlUpdateString);

	    if ((count == 1) && (count1 == 1))
		return 1;
	    else
		return 0;
	}


        private int RecordEmail() 
	       throws SQLException
        {
	    String InsertString = "insert into sponsor_email_tracking values('"
		+ (String)UserTable.get("uid") + "',sysdate,'"
		+ (String)UserTable.get("suid") 
		+ "','N','nobody',sysdate)";
	    int count = stmt.executeUpdate(InsertString);
	    return count;
	}
    
        private void LoadCtas()
	        throws SQLException
        {
	    String cta = (String)UserTable.get("cta");
	    String CtaCode = getCtaCode(cta); 
	    String queryStr = "insert into student_ctas values('"
		+ (String)UserTable.get("uid") + "','"
		+ CtaCode + "','PRIMARY')";
	    int count = stmt.executeUpdate(queryStr);
	
	    String cta2[] = (String[])UserTable.get("cta2");
	    int len = cta2.length;
	    for (int i=0; i<len; i++) {
		CtaCode = getCtaCode(cta2[i]);
		queryStr = "insert into student_ctas(student_uid,cta) values('"
		    + (String)UserTable.get("uid") + "','"
		    + CtaCode + "')";
		count =  stmt.executeUpdate(queryStr);
		}
	}

        private String getCtaCode(String cta) 
        {
	    return cta.substring(0,3);
	}

        private void UpdateCtas() 
	       throws SQLException
        {
	    int count = stmt.executeUpdate("delete from student_ctas where student_uid='" + (String)UserTable.get("uid") + "'");
	    LoadCtas();
	}

        private void BackHome(PrintWriter out) 
        {
	    out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + (String)UserTable.get("admin") + "\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back To Menu\">");
	}
    
        private void BackMainHome(PrintWriter out)
        {
	    out.println("<form method=\"GET\" action=\"ascdb.users.WelcomePage\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
        }
	
        private void UpdateAccept()
	      throws SQLException
        {
	    int count = stmt.executeUpdate("update sponsor_email_tracking set accept='Y',modified_date=sysdate, modified_by='" + (String)UserTable.get("admin") + "' where oracle_uid = '" + (String)UserTable.get("uid") + "' and sponsor_uis='" + (String)UserTable.get("suid") + "'");
	}

    
        public void doGet(HttpServletRequest req, HttpServletResponse res)
	    throws ServletException, IOException
        {
	    doPost(req,res);
	}

}
	 


	    
